//********************************************************************
//*** ResourcePool/mysql/MysqlException.hh
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: MysqlException.hh,v 1.8 2008/01/27 16:42:28 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */


#ifndef RESOURCEPOOL_MYSQL_MYSQLEXCEPTION_HH
#define RESOURCEPOOL_MYSQL_MYSQLEXCEPTION_HH

#ifndef RESOURCEPOOL_SQL_SQLException_HH
#include "ResourcePool/SQL/SQLException.hh"
#endif

#ifndef RESOURCEPOOL_NOFAILOVEREXCEPTION_HH
#include "ResourcePool/NoFailoverException.hh"
#endif

namespace fatalmind {

class MysqlException: virtual public SQL::SQLException {
	public:
		MysqlException(const std::string& message, const int errorcode, const std::string& sql);
		int getErrorCode() const throw();
	
		static void throwit(const int rv, const std::string& msg, const int errorcode, const std::string& sql);
		
	protected:
		static const char* mapMYSQLtoXOPEN(const int errorcode);
	private:
		const int _errorcode;
};

class NFOMysqlException: virtual public MysqlException, virtual public NoFailoverException {
	public:
		NFOMysqlException(const std::string& message, const int errorcode, const std::string& sql);
};

} // namespace fatalmind
#endif
