#include "config.h"
#include <stdlib.h>

typedef fatalmind::ResourcePool<fatalmind::ResourceType::mysql> RP;

std::string getConnectString() {
	char *cstr = getenv("FATALMIND_RESOURCEPOOL_MYSQL");
	if (cstr != NULL) {
		std::string connect(cstr);
		if (connect.length()) {
			return connect;
		}
	} 
	throw fatalmind::SkippedException("No MySQL testdatabase set (use FATALMIND_RESOURCEPOOL_MYSQL)");
}

RP::Factory getFactory() {
	return RP::Factory(getConnectString());
}


void clear(RP& p) {
	RP::Command::SQLExecute sql("delete from hirsch");
	p.execute(sql);
}

void drop(RP& p) {
	try {
		RP::Command::SQLExecute sql("drop table hirsch");
		p.execute(sql);
	} catch (...) {
	}
}

void init(RP& p) {
	drop(p);
	RP::Command::SQLExecute sql(
		"create table hirsch (id numeric not null primary key, ukn varchar(255))  ENGINE=InnoDB"
	);
	p.execute(sql);
}
