//********************************************************************
//*** ResourcePool/oracle/OCIEnvHandle.hh
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: OCIEnvHandle.cc,v 1.10 2008/01/27 16:42:29 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_ORACLE_OCIENVHANDLE_HH
#include "OCIEnvHandle.hh"
#endif

#ifndef RESOURCEPOOL_ORACLE_ORACLEEXCEPTIONFACTORY_HH
#include "OracleExceptionFactory.hh"
#endif

//#include <iostream>

namespace fatalmind {
namespace oracle {

OCIEnvHandle::OCIEnvHandle(const unsigned int mode)
{
	sword ret;
	if ((ret = OCIEnvCreate((OCIEnv **) &_h
		, (ub4) mode
		, (dvoid *) 0
		, (dvoid * (*)(dvoid *,size_t)) 0
		, (dvoid * (*)(dvoid *, dvoid *, size_t)) 0
		, (void (*)(dvoid *, dvoid *)) 0
		, (size_t) 0
		, (dvoid **) 0)
	) != OCI_SUCCESS) {
		OracleExceptionFactory::throwit("OCIEnvCreate", *this, ret, "");
    }
}

OCIEnvHandle::~OCIEnvHandle()
{
	OCIHandleFree((dvoid *)_h, OCI_HTYPE_ENV);
}

OCIEnv* OCIEnvHandle::get() const
{
	return _h;
}

} // namespace oracle
} // namespace fatalmind
