//********************************************************************
//*** ResourcePool/oracle/SQLSelectRow.t.cc
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: SQLSelectRow.t.cc,v 1.19.2.1 2008/03/21 21:18:54 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#include "ResourcePool/oracle/ResourcePool.hh"
#include "t/main.hh"

#include "testconfig.cc"
#include "../SQL/SQLSelectRow.t.cc"

#include "cache/Cache.hh"
#include "Resource.cc"
#include "ResourcePool/ResourcePool.cc"
#include "ResourcePool/Execute.cc"
#include "ResourcePool/Command.cc"
#include "SelectListMetaDataCache.hh"

std::auto_ptr<RP> rp;

void INIT_oracle_SQLSelectRow() {
    rp.reset(new RP(getFactory()));
    test_SQLSelectRow_init(*rp);
}

void TEST_oracle_SQLSelectRow_one()
{
	test_SQLSelectRow_one(*rp);
}

void TEST_PERF_oracle_SQLSelectRow_one_spec_outer_C() {
	test_perf_SQLSelectRow_one_spec_outer(*rp);
}


void TEST_PERF_oracle_SQLSelectRow_one_spec_inner_C() {
	test_perf_SQLSelectRow_one_spec_inner(*rp);
}

void TEST_PERF_oracle_SQLSelectRow_first_one()
{
	test_perf_SQLSelectRow_first_one(*rp);
}

void CLEANUP_oracle_SQLSelectRow() {
	test_SQLSelectRow_cleanup(*rp);
}

