//********************************************************************
//*** operators/epsilon_eq.cc
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: epsilon_eq.cc,v 1.4 2008/01/27 16:42:29 mws Exp $
//********************************************************************

#ifndef OPERATORS_EPSILON_EQ_HH
#include "epsilon_eq.hh"
#endif

#include <cmath>
#include <limits>
#include <iostream>

namespace fatalmind {
namespace operators {
	template<typename T>
	bool _epsilon_eq(const T lho, const T rho) {
		//std::cerr << "epsilon_eq: " << lho << "==" << rho <<  "  epsilon: " << std::numeric_limits<T>::epsilon() << "   diff " << std::abs(lho - rho) << std::endl;
		return (std::abs(lho - rho) <= std::numeric_limits<T>::epsilon());
	}

	bool epsilon_eq(const float lho, const float rho) {
		return _epsilon_eq(lho, rho);
	}

	bool epsilon_eq(const double lho, const double rho) {
		return _epsilon_eq(lho, rho);
	}
}
}
