#include "Clone.hh"

#include "../t/main.hh"

using namespace fatalmind;

class Xclonable: public Clone {
	public:
		int x;
	protected:
		virtual Xclonable* DoClone() const {
			return new Xclonable(*this);
		}
};

class Yclonable: public Xclonable {
};

void TEST_Clone() {
	Xclonable* p1 = new Xclonable();
	p1->x = 5;
	Xclonable* p2 = p1->clone<Xclonable>();
	assertNotEqualT(void*, p1, p2);
	assertEqual(p1->x, 5);
	assertEqual(p2->x, 5);
	p2->x = 6;
	assertEqual(p1->x, 5);
	assertEqual(p2->x, 6);
}

void TEST_CloneWrong() {
	Yclonable* p1 = new Yclonable();
	p1->x = 5;
	try {
		Clone* p2 = p1->clone();
		assertNotReach();
		assertNotEqualT(void*, p1, p2); // to make the compiler not warn about unused p2
	} catch (CloneException& e) {
	}
}
